﻿/*
 * Created by SharpDevelop.
 * User: banana
 * Date: 2013/10/23
 * Time: 14:11
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.IO;
using System.Text.RegularExpressions;

namespace PicLogic
{
	/// <summary>
	/// Description of ChallengeSheetReader.
	/// </summary>
	public class ChallengeSheetReader
	{
		public ChallengeSheetReader()
		{
		}
		
		public static Sheet Read(string path)
		{
			List<ContinuityNumber[]> vertNumbers = new List<ContinuityNumber[]>();
			List<ContinuityNumber[]> horizNumbers = new List<ContinuityNumber[]>();
			char mode = '-';
			
			using(StreamReader sr = new StreamReader(new FileStream(path, FileMode.Open, FileAccess.Read, FileShare.ReadWrite))){
				while(!sr.EndOfStream){
					string line = sr.ReadLine().Trim();
					if(string.IsNullOrEmpty(line)){
						continue;
					}
					if(line.StartsWith("[V]")){
						mode = 'V';
					}
					else if(line.StartsWith("[H]")){
						mode = 'H';
					}
					else if(Regex.IsMatch(line, "^[0-9 ]+$")){
						GetNumbers(vertNumbers, horizNumbers, mode, line);
					}
				}
			}
			
			Brock[,] brocks = new Brock[vertNumbers.Count, horizNumbers.Count];
			for(int indexX=0; indexX<vertNumbers.Count; indexX++){
				for(int indexY=0; indexY<horizNumbers.Count; indexY++){
					brocks[indexX,indexY] = new Brock();
				}
			}
			
			return new Sheet {
				VertNumbers = vertNumbers,
				HorizNumbers = horizNumbers,
				Brocks = brocks,
			};
		}
		
		private static void GetNumbers(
			List<ContinuityNumber[]> vertNumbers,
			List<ContinuityNumber[]> horizNumbers,
			char mode, string line)
		{
			List<ContinuityNumber[]> numbers = null;
			switch(mode){
				case 'V':
					numbers = vertNumbers;
					break;
				case 'H':
					numbers = horizNumbers;
					break;
			}
			if(numbers != null){
				string[] array = line.Split(new char[]{ ' ' });
				ContinuityNumber[] numArray = new ContinuityNumber[array.Length];
				for(int index=0; index<array.Length; index++){
					numArray[index] = new ContinuityNumber {
						Number = int.Parse(array[index]),
						Index = index,
					};
				}
				numbers.Add(numArray);
			}
		}
	}
}
