﻿/*
 * Created by SharpDevelop.
 * User: banana
 * Date: 2013/10/30
 * Time: 20:34
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;

namespace PicLogic.Processors
{
	/// <summary>
	/// Description of CheckCountProcessor.
	/// </summary>
	public class CheckCountProcessor : BaseProcessor
	{
		public CheckCountProcessor()
		{
		}
		
		protected override int[] Execute(ContinuityNumber[] nums, Brock[] line)
		{
			List<int> result = new List<int>();
			result.AddRange(CheckCount(nums, line));
			Array.Reverse(nums);
			Array.Reverse(line);
			result.AddRange(ReverseBrockIndexValue(CheckCount(nums, line), line.Length));
			Array.Reverse(nums);
			Array.Reverse(line);
			return result.ToArray();
		}
		
		private int[] CheckCount(ContinuityNumber[] nums, Brock[] line)
		{
			List<int> result = new List<int>();
			int numIndex=0;
			int[] work = TrySetLeft(nums, line);
			DebugLog("Current", line);
			DebugLog("Left", work);
			for(int index=0; index<line.Length; ){
				index = FindStateNotEqual(line, index, BrockState.None);
				index = FindStateEqual(line, index, BrockState.Fill);
				int count = CountSameState(line, index);
				if(index < line.Length){
					if(GetNumIndex(line[index]) >= 0){
						// 既に数インデックスが決まっている
						numIndex = FindNumber(nums, GetNumIndex(line[index]));
						log.DebugFormat("index={0}, count={1}, numIndex(set)={2}", index, count, numIndex);
					}
					else{
						// まだ決まっていないなら、
						// count 以上の数を探す
						int numIndexFound = FindNumIndexGreaterEqual(nums, numIndex, count);
						log.DebugFormat("index={0}, count={1}, numIndexFound={2}", index, count, numIndexFound);
						if(numIndexFound < nums.Length && nums[numIndexFound].Index == work[index]){
							numIndex = numIndexFound;
							result.AddRange(SetNumIndexToFill(line, index, nums[numIndex].Index));
						}
						else{
							// 割り当てる数が見つからない
							// 今回の塗り潰しの終端が、次の数の左詰めでの開始位置より左かどうか
							if(numIndex+1 < nums.Length){
								int nextStart = Find(work, 0, nums[numIndex+1].Index);
								log.DebugFormat("nextStart={0}", nextStart);
								if(nextStart < line.Length && index+count+1 < nextStart){
									result.AddRange(SetNumIndexToFill(line, index, nums[numIndex].Index));
								}
							}
							break;
						}
					}
					// 数を過ぎるか、X までを飛ばす
					int noneIndex = FindStateEqual(line, index, BrockState.None);
					int nextMaxIndex = index+nums[numIndex].Number+1;
					log.DebugFormat("noneIndex={0}, nextMaxIndex={1}", noneIndex, nextMaxIndex);
					index = Math.Min(noneIndex, nextMaxIndex);
					numIndex++;
				}
			}
			return result.ToArray();
		}
		
		private int FindNumIndexGreaterEqual(ContinuityNumber[] nums, int startIndex, int count)
		{
			for(int numIndex=startIndex; numIndex<nums.Length; numIndex++){
				if(!nums[numIndex].Fixed && nums[numIndex].Number >= count){
					return numIndex;
				}
			}
			return nums.Length;
		}
	}
}
