﻿/*
 * Created by SharpDevelop.
 * User: banana
 * Date: 2013/10/25
 * Time: 23:11
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;

namespace PicLogic.Processors
{
	/// <summary>
	/// Description of CheckFixedProcessor.
	/// </summary>
	public class CheckFixedProcessor : BaseProcessor
	{
		public CheckFixedProcessor()
		{
		}
		
		protected override int[] Execute(ContinuityNumber[] nums, Brock[] line)
		{
			List<int> result = new List<int>();
			bool lastFixed = true;
			int lastIndex = 0;
			for(int numIndex=0; numIndex<nums.Length; numIndex++){
				ContinuityNumber num = nums[numIndex];
				if(num.Fixed){
					if(lastFixed){
						result.AddRange(SetStateNone(line, lastIndex));
					}
					lastIndex = FindNumIndexEqual(line, lastIndex, num.Index);
					lastIndex = FindStateNotEqual(line, lastIndex, BrockState.Fill);
				}
				lastFixed = num.Fixed;
			}
			if(lastFixed){
				result.AddRange(SetStateNone(line, lastIndex));
			}
			return result.ToArray();
		}
		
		private int[] SetStateNone(Brock[] line, int lastIndex)
		{
			List<int> result = new List<int>();
			for(int index=lastIndex; index<line.Length && line[index].State != BrockState.Fill; index++){
				if(line[index].State != BrockState.None){
					log.DebugFormat("none:{0}", index);
					line[index].State = BrockState.None;
					result.Add(index);
				}
			}
			return result.ToArray();
		}
	}
}
