﻿/*
 * Created by SharpDevelop.
 * User: banana
 * Date: 2013/10/28
 * Time: 21:11
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;

namespace PicLogic.Processors
{
	/// <summary>
	/// 数が最大の個数並んでいるものがあれば、両端を X にする
	/// </summary>
	public class CloseMaxNumProcessor : BaseProcessor
	{
		public CloseMaxNumProcessor()
		{
		}
		
		protected override int[] Execute(ContinuityNumber[] nums, Brock[] line)
		{
			List<int> result = new List<int>();
			
			// 最大の数を求める
			int maxNumber = 0;
			List<ContinuityNumber> maxNumbers = new List<ContinuityNumber>();
			foreach(ContinuityNumber num in nums){
				if(!num.Fixed){
					if(maxNumber < num.Number){
						maxNumber = num.Number;
						maxNumbers = new List<ContinuityNumber>();
						maxNumbers.Add(num);
					}
					else if(maxNumber == num.Number){
						maxNumbers.Add(num);
					}
				}
			}
			
			// 最大の数だけ並んでいるものがあれば、両端を X にする
			for(int index=0; index<line.Length; index++){
				if(line[index].State == BrockState.Fill){
					int count = CountSameState(line, index);
					if(count == maxNumber){
						if(SetState(line, index-1, BrockState.None)){
							result.Add(index-1);
						}
						if(SetState(line, index+count, BrockState.None)){
							result.Add(index+count);
						}
						if(maxNumbers.Count == 1){
							// 候補が1つだけなら、数インデックスを設定しておく
							for(int c=0; c<count; c++){
								if(GetNumIndex(line[index+c]) < 0){
									if(SetNumIndex(line, index+c, maxNumbers[0].Index)){
										result.Add(index+c);
									}
								}
							}
						}
					}
					index += count;
				}
			}
			
			return result.ToArray();
		}
	}
}
