﻿/*
 * Created by SharpDevelop.
 * User: banana
 * Date: 2013/10/28
 * Time: 16:48
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;

namespace PicLogic.Processors
{
	/// <summary>
	/// Description of NarrowProcessor.
	/// </summary>
	public class NarrowProcessor : BaseProcessor
	{
		public NarrowProcessor()
		{
		}
		
		protected override int[] Execute(ContinuityNumber[] nums, Brock[] line)
		{
			List<int> result = new List<int>();
			result.AddRange(CheckNarrow(nums, line));
			Array.Reverse(nums);
			Array.Reverse(line);
			result.AddRange(ReverseBrockIndexValue(CheckNarrow(nums, line), line.Length));
			Array.Reverse(nums);
			Array.Reverse(line);
			return result.ToArray();
		}
		
		private int[] CheckNarrow(ContinuityNumber[] nums, Brock[] line)
		{
			List<int> result = new List<int>();
			int index=0;
			for(int numIndex=0; numIndex < nums.Length; numIndex++){
				ContinuityNumber num = nums[numIndex];
				if(num.Fixed){
					index = FindNumIndexEqual(line, index, num.Index);
					index = FindStateNotEqual(line, index, BrockState.Fill);
				}
				else{
					while(index<line.Length){
						index = FindStateNotEqual(line, index, BrockState.None);
						int noneIndex = FindStateEqual(line, index, BrockState.None);
						int count = noneIndex - index;
						log.DebugFormat("index={0}, count={1}, number={2}", index, count, num.Number);
						if(count < num.Number){
							// 数が入りきれないなら X で埋める
							result.AddRange(SetStateNone(line, index, count));
						}
						else{
							break;
						}
						index += count;
					}
					break;
				}
			}
			return result.ToArray();
		}
		
		private int[] SetStateNone(Brock[] line, int index, int length)
		{
			List<int> result = new List<int>();
			for(int count=0; count<length && index+count<line.Length; count++){
				Brock brock = line[index+count];
				if(brock.State != BrockState.None){
					if(brock.State != BrockState.Unknown){
						log.ErrorFormat("Unknownになっていない!! index={0}", index+count);
					}
					if(SetState(line, index+count, BrockState.None)){
						result.Add(index+count);
					}
				}
			}
			return result.ToArray();
		}
	}
}
