﻿/*
 * Created by SharpDevelop.
 * User: banana
 * Date: 2013/10/29
 * Time: 14:11
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;

namespace PicLogic.Processors
{
	/// <summary>
	/// 塗り潰しが届かない部分を X にする
	/// </summary>
	public class NotReachProcessor : BaseProcessor
	{
		public NotReachProcessor()
		{
		}
		
		protected override int[] Execute(ContinuityNumber[] nums, Brock[] line)
		{
			List<int> result = new List<int>();
			result.AddRange(CheckReach(nums, line));
			Array.Reverse(nums);
			Array.Reverse(line);
			result.AddRange(ReverseBrockIndexValue(CheckReach(nums, line), line.Length));
			Array.Reverse(nums);
			Array.Reverse(line);
			return result.ToArray();
		}
		
		private int[] CheckReach(ContinuityNumber[] nums, Brock[] line)
		{
			List<int> result = new List<int>();
			bool lastFixed = true;
			int index = 0;
			for(int numIndex=0; numIndex<nums.Length; numIndex++){
				ContinuityNumber num = nums[numIndex];
				log.DebugFormat("numIndex={0} index={1} {2}", numIndex, index, num.ToString());
				if(num.Fixed){
					index = FindNumIndexEqual(line, index, num.Index);
					index += CountSameState(line, index);
					lastFixed = true;
				}
				else{
					if(num.FillCount > 0 && lastFixed){
						int unknownStart = FindStateEqual(line, index, BrockState.Unknown);
						int startIndex = FindNumIndexEqual(line, index, num.Index);
						int endIndex = FindNumIndexEqualRev(line, line.Length-1, num.Index);
						log.DebugFormat("unknownStart={0}, startIndex={1}, endIndex={2}", unknownStart, startIndex, endIndex);
						if(unknownStart < startIndex){
							// 手前に空きがある
							int count = endIndex-startIndex+1;
							log.DebugFormat("count={0}", count);
							if(count < num.Number){
								int minIndex = startIndex - (num.Number - count);
								log.DebugFormat("minIndex={0}", minIndex);
								// 届かない所までを X で埋める
								for(index=unknownStart; index<minIndex; index++){
									if(SetState(line, index, BrockState.None)){
										result.Add(index);
									}
								}
							}
						}
					}
					lastFixed = false;
				}
			}
			return result.ToArray();
		}
	}
}
