﻿/*
 * Created by SharpDevelop.
 * User: banana
 * Date: 2013/10/25
 * Time: 10:50
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;

namespace PicLogic.Processors
{
	/// <summary>
	/// Description of OverlapProcessor.
	/// </summary>
	public class OverlapProcessor : BaseProcessor
	{
		public OverlapProcessor()
		{
		}
		
		protected override int[] Execute(ContinuityNumber[] nums, Brock[] line)
		{
			List<int> result = new List<int>();
			DebugLog("状態", line);
			// 先頭から詰めて配置してみる
			int[] workLine = TrySetLeft(nums, line);
			// 末尾から詰めて配置してみる
			int[] workLineRev = TrySetRight(nums, line);
			if(log.IsDebugEnabled){
				DebugLog("先頭から詰めてみた結果", workLine);
				DebugLog("末尾から詰めてみた結果", workLineRev);
			}
			// 一致した部分を確定する
			for(int index=0; index<line.Length; index++){
				if(workLine[index] >= 0 && workLine[index] == workLineRev[index]){
					if(line[index].State != BrockState.None){
						log.DebugFormat("index={0}, numIndex={1}", index, workLine[index]);
						if(line[index].State == BrockState.Unknown){
							if(SetStateAndNumIndex(line, index, BrockState.Fill, workLine[index])){
								result.Add(index);
							}
						}
					}
				}
			}
			return result.ToArray();
		}
		
	}
}
