﻿/*
 * Created by SharpDevelop.
 * User: banana
 * Date: 2013/10/28
 * Time: 23:27
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;

namespace PicLogic.Processors
{
	/// <summary>
	/// X で区切られた塗り潰しの数を確認
	/// </summary>
	public class SplitProcessor : BaseProcessor
	{
		public SplitProcessor()
		{
		}
		
		protected override int[] Execute(ContinuityNumber[] nums, Brock[] line)
		{
			List<int> result = new List<int>();
			List<Range> ranges = new List<SplitProcessor.Range>();
			int minNumber = GetMinNumber(nums);
			for(int index=0; index<line.Length; index++){
				index = FindStateNotEqual(line, index, BrockState.None);
				int fillCount = 0;
				int findIndex = 0;
				for(findIndex=index; findIndex<line.Length && line[findIndex].State != BrockState.None; findIndex++){
					if(line[findIndex].State == BrockState.Fill){
						fillCount++;
					}
				}
				if(fillCount > 0){
					ranges.Add(new Range { Start=index, End=findIndex-1 });
				}
				else{
					if(findIndex-index < minNumber){
						// 最小の数より狭い隙間は X で埋める
						for(int noneIndex=index; noneIndex<findIndex; noneIndex++){
							if(SetState(line, noneIndex, BrockState.None)){
								result.Add(noneIndex);
							}
						}
					}
				}
				index = findIndex;
			}
			if(nums.Length == ranges.Count){
				for(int numIndex=0; numIndex<nums.Length; numIndex++){
					Range range = ranges[numIndex];
					for(int index=range.Start; index<=range.End; index++){
						if(line[index].State == BrockState.Fill &&
						   GetNumIndex(line[index]) < 0){
							if(SetNumIndex(line, index, nums[numIndex].Index)){
								result.Add(index);
							}
						}
					}
				}
			}
			return result.ToArray();
		}
		
		private int GetMinNumber(ContinuityNumber[] nums)
		{
			int result = -1;
			foreach(ContinuityNumber num in nums){
				if(!num.Fixed){
					if(result < 0 || result > num.Number){
						result = num.Number;
					}
				}
			}
			return result;
		}
		
		private class Range {
			public int Start { get; set; }
			public int End { get; set; }
		}
	}
}
